Subject: Re: [PATCH v6] doc: add an explanation of Git's data model

From: Junio C Hamano <[email-masked]>
Date: Thu, 13 Nov 2025 12:07:40 -0800

"Julia Evans" <[email-masked]> writes:

> From my point of view as a Git user one of Git's biggest strengths is its
> flexibility; because branches _can_ be moved to point at a different
> commit at any time in various ways (via `git reset --hard`, `git rebase`, or
> `git commit --amend`), there's a lot of flexibility in how someone can
> choose to use Git, including never using branches at all. 
> (the flexibility is also one of the things that makes Git hard of course :) )
>
> So I'd prefer to keep editorializing about what a branch "means"
> to a minimum.

OK.

If you go to such an extreme and make readers oblivious to what a
branch means, some of the sanity measures we have (e.g., a branch
ref will never point at anything but a commit object, not even a
commit-ish tag is allowed) would become "unnecessary nuisance" to
them.  In other words, as I hinted, it takes a delicate balancing
act.